PPATH - Prime Path


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on...

Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

    1033
    1733     
    3733     
    3739     
    3779
    8779
    8179     
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Example

Input:
3
1033 8179
1373 8017
1033 1033

Output:
6
7
0

hide comments
Swapnil Borse: 2015-01-02 08:49:38

Piece of Cake!! Simple BFS it is!!! Skilled implementation is the key though :P

agaurav77: 2014-12-27 16:36:21

This one is a super awesome one. Those who don't get how to start, here's a hint : Think of Dijkstra !

AC :)

Gaurav Bansal: 2014-12-24 08:14:36

these type of questions illustrates why programming is awesome!!

yagyank: 2014-11-29 22:05:17

weak test cases!!!

mayank: 2014-11-20 07:24:26

the importance of '=' operator. '<=' and '<' can be the margin of difference of WA AC. Silliest mistake ever done! :'( .

programmer92: 2014-11-09 10:33:24

GOOD QUESTION

Last edit: 2014-11-09 10:36:12
ankit bisla: 2014-11-09 08:10:17

My 50th!!AC in first go :)

Last edit: 2014-11-09 08:10:42
do_do: 2014-11-08 19:17:02

Nice problem.. taught me a lot :P

Ishant : 2014-11-08 19:04:25

nice question :)

eti goel: 2014-10-12 21:18:42

my first graph problem..:P :P


Added by:overwise
Date:2007-10-02
Time limit:2s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: ERL JS-RHINO NODEJS PERL6 VB.NET
Resource:ACM ICPC NWERC 2006